# Xorfilter: Rust xor filter implementation

Abstract from [original authors](https://github.com/FastFilter/xorfilter): Bloom filters are used to quickly check whether an element is part of a set. Xor filters are a faster and more concise alternative to Bloom filters. They are also smaller than cuckoo filters.

## API

```rust
use Xorfilter;

fn main() {

    // create filter // default Xor8
    let mut x = Xorfilter::Xorfilter::new();
   
    let keys = vec![1, 2, 3];

    // populate keys
    x.populate(&keys);

    // check if key in the filter 
    for key in &keys {
        println!("{}", x.contains(*key));
    }

}
```
## Status

Currently only supports Xor8

## Reference

[Xor Filters: Faster and Smaller Than Bloom and Cuckoo
Filters](https://arxiv.org/abs/1912.08258), Journal of Experimental
Algorithmics.

