
#[macro_use]
extern crate criterion;
use ::Xorfilter::*;
use rand::prelude::*;
use criterion::{BenchmarkId, Criterion};


pub fn xor_contains(c: &mut Criterion) {

    
    let mut group = c.benchmark_group("Xor8");
    let group = group.sample_size(300);
    
    let size = 3;
    let mut xor_filter = Xorfilter::new();

    let keys = create_keys(size);
    
    group.bench_with_input(BenchmarkId::new("xor_contains", size), &keys, |b, keys| {
        b.iter(|| xor_filter.populate(&keys.to_vec()));
    });
}

fn create_keys(n: usize) -> Vec<u64> {
      use rand::prelude::*;
      let mut keys: Vec<u64> = Vec::with_capacity(n);
      let mut rng = rand::thread_rng();

      for i in 0..n {
         keys.push((rng.gen::<u64>()));
     }

      keys
    }


criterion_group!(xorfilter, xor_contains);
criterion_main!(xorfilter);
